/*
 * Hockey Bot Code
 *
 * $Author: flan $
 * $Date: 1994/03/01 06:54:53 $
 *
 * $Log: bot.c,v $
 * Revision 2.0  1994/03/01  06:54:53  flan
 * Autospam First Release
 *
 * Revision 1.8  1993/12/04  21:34:25  flan
 * -First Stupid Release
 *
 * Revision 1.8  1993/12/04  21:34:25  flan
 * More sayings, a spelling mistake corrected.
 *
 * Revision 1.7  1993/11/24  16:49:03  brian
 * Added defense mode to bot
 *
 * Revision 1.5  1993/11/24  10:50:45  flan
 *   Included the version.h and patchlevel.h so that we can use it in
 * DoBotAnnounce().
 *   Added the STARTINGUP variable which, if set, means that we're
 * executing the main bot loop for the first time.
 *   Added more goofy messages.
 *   Changed AnnounceBot() to use real patch & version, not RCS Revision.
 *   DoBotStart() called to initialize initial bot module.
 *   Bot main routins are now NOT passed any arguments.  It's up to them
 * to figure out what they need.  Not the main loops problem.
 *   Also, added the calls to StartSpamStrategy() and StopSpamStrategy()
 * which are now implemented.
 *
 *
 */

/* 	$Id: bot.c,v 2.0 1994/03/01 06:54:53 flan Rel $	 */

#ifndef lint
static char vcid[] = "$Id: bot.c,v 2.0 1994/03/01 06:54:53 flan Rel $";
#endif /* lint */

#include <stdio.h>
#include "config.h"
#include "copyright.h"

#include "version.h"
#include "patchlevel.h"

#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#include "bot.h"

int STARTINGUP = 1;

int autoShieldEnabled = 1;
int autoShieldDist = 1000;
int borgTarget = -1;
int torpFlightType = 0; /* Normal */
int teamPicked = 0;
int myTeam;
int myShip = SCOUT;
int lastScream = 0;

StrategyType Strategy = Spam;

static char *botSayings[] =
{
  "   Please don't hate me because I'm beautiful.",
  "   Not yet sold in stores.",
  "   It's not just for breakfast anymore.",
  "   It tastes more like fresh peanuts.",
  "   That's why I switched to Monostat 7.",
  "   It's the right thing to do.",
  "   It does a body good.",
  "   Stays crunchy in milk.",
  "   The Humpty Dance is your chance to do the hump.",
  "   Word to ya mother!",
  "   Ribbed for her pleasure.",
  "   New mintry green!",
  "   Fun for the whole fmaily.",
  "   We bring good things to life.",
  "   Ask not for whom the Spam scores, it scores for me.",
  "   Thank you for your support."
};


void
AnnounceBot( int who, int type )
{
  char buf[80];
  sprintf(buf, "%spl%d", version, PATCHLEVEL);
  pmessage(buf, who, type);
  pmessage("I am a hockey playing ROBOT.", who, type);
  pmessage("I am not a borg--there is no human playing me.", who, type);
  pmessage("Remember, AutoSpamosaurus:", who, type);
  pmessage(botSayings[RANDOM() % (sizeof(botSayings) / sizeof(char *))],
	   who, type);
}


void
DoBotStart( void )
{
  switch (Strategy)
    {
    case Null:
      StartNullStrategy();
      break;
    case Spam:
      StartSpamStrategy();
      break;
    case Defend:
      StartDefendStrategy();
      break; 
    }
}


void
DoBotThings( void )
{
  int PUCK = GetPlayerByName("Puck");
  unsigned char course_to_puck;
  long t = time(0);

  if (STARTINGUP)
    {
      DoBotStart();
      STARTINGUP = 0;
    }
  
  if (t > 300 + lastScream)
    {
      if (lastScream)
	{
	  AnnounceBot( 0, MALL );
	}
      lastScream = t;
    }

  if (PUCK < 0) return;
  
  switch (Strategy)
    {
    case Null:
      DoNullStrategy();
      break;
      
    case Spam:
      DoSpamStrategy();
      break;
      
    case Defend:
      DoDefendStrategy( PUCK, course_to_puck );
      break;
    }
}


void
DoBotMessageStuff( char *message, int len )
{
  switch (Strategy)
    {
    case Null:
      DoNullMessage( message, len );
      break;
    
    case Spam:
      DoSpamMessage( message, len );
      break;
    
    case Defend:
      DoDefendMessage( message, len );
      break; 
    }
}

void
DoGeneralMessage( char *message, int len )
{
  int from, to;

  from = GetPlayerFromMessage(&(message[1]));
  to = GetPlayerFromMessage(&(message[5]));
  
  if (((from >= 0) && (to == me->p_no))
      && (strstr(message, "ello") || strstr(message, "borg")))
    {
      AnnounceBot( from, MINDIV );
    }
  
  if (strstr(message, "NewStrategy"))
    {
      /* stop old strategy */
      switch (Strategy)
	{
	  case Null:
	    StopNullStrategy();
	    break;
	  case Spam:
	    StopSpamStrategy();
	    break;
	  case Defend:
	    StopDefendStrategy();
	    break; 
	}
    
      /* figure out the new one */
      if (strstr(message, "Null"))
	{
	  Strategy = Null;
	}
      
      if (strstr(message, "Spam"))
	{
	  Strategy = Spam;
	}

      if (strstr(message, "Defend"))
	{
	  Strategy = Defend;
	} 
      
      /* start new strategy (or old one if no new one specified)*/
      switch (Strategy)
	{
	  case Null:
	    StartNullStrategy();
	    break;
	  case Spam:
	    StartSpamStrategy();
	    break;
	  case Defend:
	    StartDefendStrategy();
	    break; 
	}
    }
}
