
/*
 * death.c
 */
#include "config.h"
#include "copyright.h"

#include <stdio.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/types.h>

#include <time.h>
#include INC_SYS_TIME

#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"

extern jmp_buf env;

static struct itimerval udt;
static char *teamstring[9] =
{"", "and the Feds",
 "and the Roms", "",
 "and the Klis", "", "", "",
 "and the Oris"};

death ()
{
  char buf[80];
  W_Event event;
  W_Window oldw;
  oldw = w;

#ifdef AUTOKEY
  if (autoKey)
    autoKeyAllOff ();
#endif /*AUTOKEY */

#ifdef nodef
  /* Reset the signal */
  SIGNAL (SIGALRM, SIG_IGN);
  udt.it_interval.tv_sec = 0;
  udt.it_interval.tv_usec = 0;
  udt.it_value.tv_sec = 0;
  udt.it_value.tv_usec = 0;
  setitimer (ITIMER_REAL, &udt, 0);
  SIGNAL (SIGALRM, SIG_DFL);
#endif

  W_ClearWindow (w);
  W_ClearWindow (iconWin);
  if (oldalert != PFGREEN)
    {
      if (extraBorder)
	W_ChangeBorder (oldw, gColor);
      W_ChangeBorder (baseWin, gColor);
      oldalert = PFGREEN;
    }
  if (W_IsMapped (statwin))
    {
      W_UnmapWindow (statwin);
      showStats = 1;
    }
  else
    {
      showStats = 0;
    }
  if (infomapped)
    destroyInfo ();
  W_UnmapWindow (planetw);
  W_UnmapWindow (rankw);
  W_UnmapWindow (war);
  if (optionWin)
    optiondone ();
#ifdef SOUND
  if (soundWin)
    sounddone ();
#endif
  STRNCPY (deathmessage, "", 1);
  switch (me->p_whydead)
    {
    case KQUIT:
      sprintf (buf, "           You QUIT!!");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KTORP:
      sprintf (buf, "You were thumped by a photon torpedo from %s (%c%c).",
	       players[me->p_whodead].p_name,
	       teamlet[players[me->p_whodead].p_team],
	       shipnos[me->p_whodead]);
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KPLASMA:
      sprintf (buf, "You were SMACKed by a plasma torpedo from %s (%c%c) ",
	       players[me->p_whodead].p_name,
	       teamlet[players[me->p_whodead].p_team],
	       shipnos[me->p_whodead]);
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KPHASER:
      sprintf (buf, "You were phasered to death by %s (%c%c)",
	       players[me->p_whodead].p_name,
	       teamlet[players[me->p_whodead].p_team],
	       shipnos[me->p_whodead]);
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KPLANET:
      sprintf (buf, "You were killed by planetary fire from %s (%c)",
	       planets[me->p_whodead].pl_name,
	       teamlet[planets[me->p_whodead].pl_owner]);
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KSHIP:
      sprintf (buf, "You were killed by the explosion of %s (%c%c)",
	       players[me->p_whodead].p_name,
	       teamlet[players[me->p_whodead].p_team],
	       shipnos[me->p_whodead]);
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KDAEMON:
      sprintf (buf, "You were killed by a dying daemon.");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KWINNER:
      sprintf (buf, "Galaxy has been conquered by %s (%c%c) %s",
	       players[me->p_whodead].p_name,
	       teamlet[players[me->p_whodead].p_team],
	       shipnos[players[me->p_whodead].p_no],
	       teamstring[players[me->p_whodead].p_team]);
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_BoldFont);
      if (babes)
	genokathy ();
      break;
    case KGHOST:
      sprintf (buf, "You were killed by a confused daemon.");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KGENOCIDE:
      sprintf (buf, "You were GENOCIDED by %s (%c%c) %s. You suck!",
	       players[me->p_whodead].p_name,
	       teamlet[players[me->p_whodead].p_team],
	       shipnos[me->p_whodead],
	       teamstring[players[me->p_whodead].p_team]);
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_BoldFont);
      break;
    case KPROVIDENCE:
      sprintf (buf, "You were nuked by GOD.");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KOVER:
      sprintf (buf, "The game is  over!");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case TOURNSTART:
      sprintf (buf, "The tournament game has begun!");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case TOURNEND:
      sprintf (buf, "The tournament game has ended.");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    case KBADBIN:
      sprintf (buf, "Your netrek executable didn't verify correctly.");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    default:
      sprintf (buf, "You were killed by something unknown to this game?");
      W_WriteText (w, 50, 80, textColor, buf, strlen (buf), W_RegularFont);
      break;
    }
  STRNCPY (deathmessage, buf, sizeof (deathmessage));

  if (promoted)
    {
      sprintf (buf, "Congratulations, You have scummed up to %s",
	       ranks[mystats->st_rank].name);
      W_WriteText (w, 50, 100, W_Yellow, buf, strlen (buf), W_BoldFont);
      promoted = 0;
    }
  w = oldw;
  while (W_EventsPending ())
    {
      W_NextEvent (&event);
    }
  longjmp (env, 0);
}

updatedeath ()
{
  W_WriteText (w, 50, 80, W_Yellow, deathmessage, strlen (deathmessage),
	       W_BoldFont);
}
