
/*
 * input.c
 *
 * $Revision: 2.0 $
 * $Log: input.c,v $
 * Revision 2.0  1994/03/01  06:51:42  flan
 * Autospam First Release
 *
 * Revision 1.1  1994/03/01  05:14:18  flan
 * Added Autospam Code.
 * Added Version Tracking headers.
 *
 */
/* 	$Id: input.c,v 2.0 1994/03/01 06:51:42 flan Rel $	 */

#ifndef lint
static char vcid[] = "$Id: input.c,v 2.0 1994/03/01 06:51:42 flan Rel $";
#endif /* lint */

#include "config.h"
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>
#include INC_SYS_TIME
#include INC_SYS_SELECT
#include INC_STRINGS
#include <signal.h>
#include <errno.h>

#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"
int detallow = 1;		/* flag used to figure out if we're allowing det */

#ifdef DOC_WIN
static int docline = 0;
static int xtrekrcline = 0;
#endif

static int opened_info = -2;	/* counter for infowin popup, 6/1/93 LAB */
struct obtype *gettarget (), *target;
unsigned char key = ' ';

/* this used to be 177 for an unknown reason...I think it may
   ** have included various control characters.  We don't support
   ** those anyway right?? - jn
 */
#define MAXKEY 224
#define MAXASCII 128

/* this method of avoiding a massive switch should represent
   ** massive performance gains... instead of having to test
   ** n/2 times for n different keys, the key is run directly
   ** via an array of input functions whose index happens
   ** to coorespond to the value of input char. - jn
 */
int emptyKey (), Key32 (), Key33 (), Key34 (), Key35 (), Key36 (), Key37 (),
  Key38 (), Key39 (), Key40 (), Key41 (), Key42 (), Key43 (), Key44 (),
  Key45 (), Key46 (), Key47 (), Key48 (), Key49 (), Key50 (), Key51 (),
  Key52 (), Key53 (), Key54 (), Key55 (), Key56 (), Key57 (), Key58 (),
  Key59 (), Key60 (), Key61 (), Key62 (), Key63 (), Key64 (), Key65 (),
  Key66 (), Key67 (), Key68 (), Key69 (), Key70 (), Key71 (), Key72 (),
  Key73 (), Key74 (), Key75 (), Key76 (), Key77 (), Key78 (), Key79 (),
  Key80 (), Key81 (), Key82 (), Key83 (), Key84 (), Key85 (), Key86 (),
  Key87 (), Key88 (), Key89 (), Key90 (), Key91 (), Key92 (), Key93 (),
  Key94 (), Key95 (), Key96 (), Key97 (), Key98 (), Key99 (), Key100 (),
  Key101 (), Key102 (), Key103 (), Key104 (), Key105 (), Key106 (), Key107 (),
  Key108 (), Key109 (), Key110 (), Key111 (), Key112 (), Key113 (), Key114 (),
  Key115 (), Key116 (), Key117 (), Key118 (), Key119 (), Key120 (), Key121 (),
  Key122 (), Key123 (), Key124 (), Key125 (), Key126 (), Key127 ();

/* control keys */
int Key131 (), Key144 (), Key145 (), Key146 (), Key147 (), Key148 (), Key149 (),
  Key150 (), Key151 (), Key152 (), Key153 (), Key160 (), Key162 (), Key163 (),
  Key175 (), Key180 (), Key194 (), Key195 (), Key197 (), Key198 (), Key200 (),
  Key206 (), Key207 (), Key204 (), Key205 (), Key208 (), Key212 ();

typedef struct
  {
    int (*handler) ();
  }

key_handler_type;

key_handler_type key_handlers[MAXKEY] =
{
  emptyKey,			/* \0 */
  emptyKey,			/* 1 */
  emptyKey,			/* 2 */
  emptyKey,			/* 3 */
  emptyKey,			/* 4 */
  emptyKey,			/* 5 */
  emptyKey,			/* 6 */
  emptyKey,			/* 7 */
  emptyKey,			/* 8 */
  emptyKey,			/* 9 */
  emptyKey,			/* 10 */
  emptyKey,			/* 11 */
  emptyKey,			/* 12 */
  emptyKey,			/* 13 */
  emptyKey,			/* 14 */
  emptyKey,			/* 15 */
  emptyKey,			/* 16 */
  emptyKey,			/* 17 */
  emptyKey,			/* 18 */
  emptyKey,			/* 19 */
  emptyKey,			/* 20 */
  emptyKey,			/* 21 */
  emptyKey,			/* 22 */
  emptyKey,			/* 23 */
  emptyKey,			/* 24 */
  emptyKey,			/* 25 */
  emptyKey,			/* 26 */
  emptyKey,			/* 27 */
  emptyKey,			/* 28 */
  emptyKey,			/* 29 */
  emptyKey,			/* 30 */
  emptyKey,			/* 31 */

  Key32,			/* space */
  Key33,			/* ! */
  Key34,			/* "" */
  Key35,			/* # */
  Key36,			/* $ */
  Key37,			/* % */
  Key38,			/* & */
  Key39,			/* ' */
  Key40,			/* ( */
  Key41,			/* ) */
  Key42,			/* * */
  Key43,			/* + */
  Key44,			/* , */
  Key45,			/* - */
  Key46,			/* . */
  Key47,			/* / */
  Key48,			/* 0 */
  Key49,			/* 1 */
  Key50,			/* 2 */
  Key51,			/* 3 */
  Key52,			/* 4 */
  Key53,			/* 5 */
  Key54,			/* 6 */
  Key55,			/* 7 */
  Key56,			/* 8 */
  Key57,			/* 9 */
  Key58,			/* : */
  Key59,			/* ; */
  Key60,			/* < */
  Key61,			/* = */
  Key62,			/* > */
  Key63,			/* ?  -  you know this is boring as hell... */
  Key64,			/* @ */
  Key65,			/* A */
  Key66,			/* B */
  Key67,			/* C */
  Key68,			/* D */
  Key69,			/* E */
  Key70,			/* F */
  Key71,			/* G */
  Key72,			/* H */
  Key73,			/* I */
  Key74,			/* J */
  Key75,			/* K */
  Key76,			/* L */
  Key77,			/* M */
  Key78,			/* N */
  Key79,			/* O */
  Key80,			/* P */
  Key81,			/* Q */
  Key82,			/* R */
  Key83,			/* S */
  Key84,			/* T */
  Key85,			/* U */
  Key86,			/* V */
  Key87,			/* W */
  Key88,			/* X */
  Key89,			/* Y */
  Key90,			/* Z */
  Key91,			/* [ */
  Key92,			/* \ */
  Key93,			/* ]  -  ascii is fucked... */
  Key94,			/* ^ */
  Key95,			/* _ */
  Key96,			/* ` */
  Key97,			/* a */
  Key98,			/* b */
  Key99,			/* c */
  Key100,			/* d */
  Key101,			/* e */
  Key102,			/* f */
  Key103,			/* g */
  Key104,			/* h */
  Key105,			/* i */
  Key106,			/* j */
  Key107,			/* k */
  Key108,			/* l */
  Key109,			/* m */
  Key110,			/* n */
  Key111,			/* o */
  Key112,			/* p */
  Key113,			/* q */
  Key114,			/* r */
  Key115,			/* s */
  Key116,			/* t */
  Key117,			/* u */
  Key118,			/* v */
  Key119,			/* w */
  Key120,			/* x */
  Key121,			/* y */
  Key122,			/* z */
  Key123,			/* { */
  Key124,			/* | */
  Key125,			/* } - my wife was once bitten by a lhama */
  Key126,			/* ~ */
  Key127,			/* delete */
  emptyKey,			/* 128 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key131,			/* ^# */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key144,			/* ^0 */
  Key145,			/* ^1 */
  Key146,			/* ^2 */
  Key147,			/* ^3 */
  Key148,			/* ^4 */
  Key149,			/* ^5 */
  Key150,			/* ^6 */
  Key151,			/* ^7 */
  Key152,			/* ^8 */
  Key153,			/* ^9 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key160,			/* ^@ */
  emptyKey,			/* 31 */
  Key162,			/* ^B */
  Key163,			/* ^C */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key175,			/* ^O */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key180,			/* ^T */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key194,			/* ^b */
  Key195,			/* ^c */
  emptyKey,			/* 31 */
  Key197,			/* ^e */
  Key198,			/* ^f */
  emptyKey,			/* 31 */
  Key200,			/* ^h */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key204,			/* ^l */
  Key205,			/* ^m */
  Key206,			/* ^n */
  Key207,			/* ^o */
  Key208,			/* ^p */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  Key212,			/* ^t */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 31 */
  emptyKey,			/* 223 */
};

unsigned char
getctrlkey (unsigned char **s)
{
  unsigned char *str = *s;
  unsigned char c;

  /* Character is control key. */
  if (*str == '^')
    {
      str++;
      /* check for '^' key being specified with "^^" */
      if (*str != '^')
	c = *str + 96;
      else
	c = *str;
    }
  else
    c = *str;
  str++;
  *s = str;
  return (c);
}

initkeymap ()
{
  unsigned char *str;
  unsigned char c1, c2;

  /* in the future let me strongly recommed we move keymap
** completely outside of the stats structure. - jn
*/


  if ((str = (unsigned char *) getdefault ("keymap")) != NULL)
    {
      while (*str != '\0')
	{
	  if (*str >= 32 && *str < 128)
	    {
	      mystats->st_keymap[*str - 32] = *(str + 1);
	    }
	  str += 2;
	}
    }

  if ((str = (unsigned char *) getdefault ("ckeymap")) != NULL)
    {
      unsigned char c1, c2;

      while (*str != '\0')
	{

	  if (*str >= 32 && *str < MAXASCII)
	    {
	      c1 = getctrlkey (&str) - 32;
	      c2 = getctrlkey (&str);
	      mystats->st_keymap[c1] = c2;
	    }

	}
    }

#ifdef MOUSE_AS_SHIFT
  if ((str = (unsigned char *) getdefault ("b1keymap")) != NULL)
    {
      b1_as_shift = 1;
      while (*str != '\0')
	{
	  if (*str >= 32 && *str < 176)
	    {
	      mystats->st_keymap[*str - 32 + 192] = *(str + 1);
	    }
	  str += 2;
	}
    }

  if ((str = (unsigned char *) getdefault ("b2keymap")) != NULL)
    {
      b2_as_shift = 1;
      while (*str != '\0')
	{
	  if (*str >= 32 && *str < 176)
	    {
	      mystats->st_keymap[*str - 32 + 288] = *(str + 1);
	    }
	  str += 2;
	}
    }

  if ((str = (unsigned char *) getdefault ("b3keymap")) != NULL)
    {
      b3_as_shift = 1;
      while (*str != '\0')
	{
	  if (*str >= 32 && *str < 176)
	    {
	      mystats->st_keymap[*str - 32 + 384] = *(str + 1);
	    }
	  str += 2;
	}
    }
#endif

  /* note: not stored on server */
  if ((str = (unsigned char *) getdefault ("buttonmap")) != NULL)
    {
      while (*str != '\0')
	{
	  switch (*str++)
	    {
	    case '1':
	      buttonmap[1] = getctrlkey (&str);
	      break;
	    case '2':
	      buttonmap[2] = getctrlkey (&str);
	      break;
	    case '3':
	      buttonmap[3] = getctrlkey (&str);
	      break;

#ifdef SHIFTED_MOUSE
	    case '4':
	      buttonmap[4] = getctrlkey (&str);
	      break;
	    case '5':
	      buttonmap[5] = getctrlkey (&str);
	      break;
	    case '6':
	      buttonmap[6] = getctrlkey (&str);
	      break;
	    case '7':
	      buttonmap[7] = getctrlkey (&str);
	      break;
	    case '8':
	      buttonmap[8] = getctrlkey (&str);
	      break;
	    case '9':
	      buttonmap[9] = getctrlkey (&str);
	      break;
	    case 'a':
	      buttonmap[10] = getctrlkey (&str);
	      break;
	    case 'b':
	      buttonmap[11] = getctrlkey (&str);
	      break;
	    case 'c':
	      buttonmap[12] = getctrlkey (&str);
	      break;
#endif

	    default:
	      fprintf (stderr, "%c ignored in buttonmap\n", *(str - 1));
	      break;
	    }
	}
    }

}

initinput ()
{
  /* Nothing doing... */
}

RETSIGTYPE
detsetallow ()
{
  detallow = 1;
}

#ifdef BRMH
input ()
{
  fd_set readfds;
  register
  int xsock = W_Socket ();	/* put it in a register */
  register
  int doflush = 0;

  while (1)
    {

      if (keepInfo > 0 && opened_info != -2 &&	/* 6/1/93 LAB */
	  opened_info < 0 && infomapped)
	destroyInfo ();

      if (keepInfo > 0 && opened_info != -2)
	opened_info--;

      FD_ZERO (&readfds);
      FD_SET (xsock, &readfds);
      FD_SET (sock, &readfds);

      if (udpSock >= 0)
	FD_SET (udpSock, &readfds);

      /* Skip read from server if select results in error. */
      if (select (max_fd, &readfds, 0, 0, 0) > 0)
	{
	  if (FD_ISSET (xsock, &readfds))
	    {
	      process_event ();
	      /* NOTE: we're no longer calling XPending(), need this */
	      doflush = 1;
	    }

	  if (FD_ISSET (sock, &readfds) ||
	      (udpSock >= 0 && FD_ISSET (udpSock, &readfds)))
	    {
	      intrupt (&readfds);
	      /* NOTE: we're no longer calling XPending(), need this */
	      doflush = 1;
	      if (isServerDead ())
		{
		  printf ("Whoops!  We've been ghostbusted!\n");
		  printf ("Pray for a miracle!\n");
		  /* UDP fail-safe */
		  commMode = commModeReq = COMM_TCP;
		  commSwitchTimeout = 0;
		  if (udpSock >= 0)
		    closeUdpConn ();
		  if (udpWin)
		    {
		      udprefresh (UDP_CURRENT);
		      udprefresh (UDP_STATUS);
		    }
		  connectToServer (nextSocket);
		  printf ("Yea!  We've been resurrected!\n");
		}
	    }
	}

      /* NOTE: we're no longer calling XPending(), need this */
      if (doflush)
	{
	  W_Flush ();
	  doflush = 0;
	}

      DoBotThings();		/* Hockey Bot Loop Stuff */
      
    }
}

process_event ()
{
  W_Event data;
  int loop = 0;
  W_Callback handler;

  do
    {
      loop++;
      if (!W_SpNextEvent (&data))
	continue;		/* continues at loop bottom */

      switch ((int) data.type)
	{
	case W_EV_KEY:
	  if ((handler = W_GetWindowKeyDownHandler (data.Window)) != NULL)
	    (*handler) (&data);
#ifdef DOC_WIN
	  else if (data.Window == docwin)
	    switch (data.key)
	      {
	      case 'f':
		docline += 28;

		if (docline >= maxdoclines)
		  docline = maxdoclines - 28;

		showdocs (docline);
		break;
	      case 'b':
		docline -= 28;

		if (docline < 0)
		  docline = 0;

		showdocs (docline);
		break;
	      case 'F':
		docline += 4;

		if (docline >= maxdoclines)
		  docline = maxdoclines - 28;

		showdocs (docline);
		break;
	      case 'B':
		docline -= 4;

		if (docline < 0)
		  docline = 0;

		showdocs (docline);
		break;
	      default:
		data.Window = w;
		keyaction (&data);
		break;
	      }
	  else if (data.Window == xtrekrcwin)
	    switch (data.key)
	      {
	      case 'f':
		xtrekrcline += 28;

		if (xtrekrcline >= maxxtrekrclines)
		  xtrekrcline = maxxtrekrclines - 28;

		showxtrekrc (xtrekrcline);
		break;
	      case 'b':
		xtrekrcline -= 28;

		if (xtrekrcline < 0)
		  xtrekrcline = 0;

		showxtrekrc (xtrekrcline);
		break;
	      case 'F':
		xtrekrcline += 4;

		if (xtrekrcline >= maxxtrekrclines)
		  xtrekrcline = maxxtrekrclines - 28;

		showxtrekrc (xtrekrcline);
		break;
	      case 'B':
		xtrekrcline -= 4;

		if (xtrekrcline < 0)
		  xtrekrcline = 0;

		showxtrekrc (xtrekrcline);
		break;
	      default:
		data.Window = w;
		keyaction (&data);
		break;
	      }
#endif
	  else if (messageon)
	    smessage (data.key);
	  else
	    keyaction (&data);
	  break;

	case W_EV_BUTTON:
	  if ((handler = W_GetWindowButtonHandler (data.Window)) != NULL)
	    (*handler) (&data);
	  else
	    buttonaction (&data);
	  break;

	case W_EV_EXPOSE:
	  if ((handler = W_GetWindowExposeHandler (data.Window)) != NULL)
	    (*handler) (&data);
	  else if (data.Window == mapw)
	    redrawall = 1;
	  else if (data.Window == warnw)
	    W_ClearWindow (warnw);
	  else if (data.Window == messagew)
	    W_ClearWindow (messagew);
#ifdef XTREKRC_HELP
	  else if (defWin && (data.Window == defWin))
	    showdef ();
#endif
#ifdef DOC_WIN
	  else if (docwin && (data.Window == docwin))
	    showdocs (docline);
	  else if (xtrekrcwin && (data.Window == xtrekrcwin))
	    showxtrekrc (xtrekrcline);
#endif
	  break;

	default:
	  break;
	}
    }
  while (W_EventsQueued ());
  return loop;
}

#else
input ()
{
  W_Event data;
  W_Callback handler;
  fd_set readfds;
  struct timeval timeout;

#ifdef AUTOKEY
  timeout.tv_sec = 0;
  timeout.tv_usec = 100000;
#endif /*AUTOKEY */

  while (1)
    {
      while (!W_EventsPending ())
	{
	  if (keepInfo > 0 && opened_info != -2 &&	/* 6/1/93 LAB */
	      opened_info < 0 && infomapped)
	    destroyInfo ();
	  if (keepInfo > 0 && opened_info != -2)
	    opened_info--;

	  FD_ZERO (&readfds);
	  FD_SET (W_Socket (), &readfds);
	  FD_SET (sock, &readfds);
	  if (udpSock >= 0)
	    FD_SET (udpSock, &readfds);

#ifdef AUTOKEY
	  if (autoKey)
	    {
	      doAutoKey ();
	      if (select (32, &readfds, 0, 0, &timeout) == 0)	/* timeout */
		continue;
	    }
	  else
	    select (32, &readfds, 0, 0, 0);
#else
	  select (32, &readfds, 0, 0, 0);
#endif

	  if (FD_ISSET (sock, &readfds) ||
	      (udpSock >= 0 && FD_ISSET (udpSock, &readfds)))
	    {
	      intrupt ();
	      if (isServerDead ())
		{
		  if (babes)
		    ghostkathy ();
		  printf ("Shit, We've been ghostbusted\n");
		  printf ("hope you're not in a base\n");
		  /* UDP fail-safe */
		  commMode = commModeReq = COMM_TCP;
		  commSwitchTimeout = 0;
		  if (udpSock >= 0)
		    closeUdpConn ();
		  if (udpWin)
		    {
		      udprefresh (UDP_CURRENT);
		      udprefresh (UDP_STATUS);
		    }
		  connectToServer (nextSocket);
		  printf ("We've been resurrected!\n");
		  map ();
		}
	    }
	  if (FD_ISSET (W_Socket (), &readfds))
	    continue;		/* we're forced to call W_EventsPending at the top */
	}
      W_NextEvent (&data);
      switch ((int) data.type)
	{

#ifdef MOUSE_AS_SHIFT
	case W_EV_MKEY:
	  if ((handler = W_GetWindowKeyDownHandler (data.Window)) != NULL)
	    (*handler) (&data);
	  else if (messageon)
	    smessage (data.key);
	  else if (mouse_as_shift)
	    mkeyaction (&data);
	  else
	    keyaction (&data);
	  break;
#endif

	case W_EV_KEY:

#ifdef DEBUG
	  printf ("W_EV_KEY\n");
#endif

	  if ((handler = W_GetWindowKeyDownHandler (data.Window)) != NULL)
	    (*handler) (&data);
#ifdef DOC_WIN
	  else if (data.Window == docwin)
	    switch (data.key)
	      {
	      case 'f':
		docline += 28;

		if (docline >= maxdoclines)
		  docline = maxdoclines - 28;

		showdocs (docline);
		break;
	      case 'b':
		docline -= 28;

		if (docline < 0)
		  docline = 0;

		showdocs (docline);
		break;
	      case 'F':
		docline += 4;

		if (docline >= maxdoclines)
		  docline = maxdoclines - 28;

		showdocs (docline);
		break;
	      case 'B':
		docline -= 4;

		if (docline < 0)
		  docline = 0;

		showdocs (docline);
		break;
	      default:
		data.Window = w;
		keyaction (&data);
		break;
	      }
	  else if (data.Window == xtrekrcwin)
	    switch (data.key)
	      {
	      case 'f':
		xtrekrcline += 28;

		if (xtrekrcline >= maxxtrekrclines)
		  xtrekrcline = maxxtrekrclines - 28;

		showxtrekrc (xtrekrcline);
		break;
	      case 'b':
		xtrekrcline -= 28;

		if (xtrekrcline < 0)
		  xtrekrcline = 0;

		showxtrekrc (xtrekrcline);
		break;
	      case 'F':
		xtrekrcline += 4;

		if (xtrekrcline >= maxxtrekrclines)
		  xtrekrcline = maxxtrekrclines - 28;

		showxtrekrc (xtrekrcline);
		break;
	      case 'B':
		xtrekrcline -= 4;

		if (xtrekrcline < 0)
		  xtrekrcline = 0;

		showxtrekrc (xtrekrcline);
		break;
	      default:
		data.Window = w;
		keyaction (&data);
		break;
	      }
#endif
	  else if (messageon)
	    smessage (data.key);
	  else
	    keyaction (&data);
	  break;

#ifdef AUTOKEY
	case W_EV_KEY_OFF:

#ifdef DEBUG
	  printf ("W_EV_KEY_OFF\n");
#endif

	  if ((handler = W_GetWindowKeyUpHandler (data.Window)) != NULL)
	    (*handler) (&data);
	  if (autoKey)
	    autoKeyOff (&data);
	  break;
#endif /*AUTOKEY */

	case W_EV_BUTTON:

#ifdef DEBUG
	  printf ("W_EV_BUTTON\n");
#endif

	  if ((handler = W_GetWindowButtonHandler (data.Window)) != NULL)
	    (*handler) (&data);
	  else
	    buttonaction (&data);
	  break;

	case W_EV_EXPOSE:

#ifdef DEBUG
	  printf ("W_EV_EXPOSE\n");
#endif

	  if ((handler = W_GetWindowExposeHandler (data.Window)) != NULL)
	    (*handler) (&data);
	  else if (data.Window == mapw)
	    redrawall = 1;
	  else if (data.Window == warnw)
	    W_ClearWindow (warnw);
	  else if (data.Window == messagew)
	    W_ClearWindow (messagew);
#ifdef XTREKRC_HELP
	  else if (defWin && (data.Window == defWin))
	    showdef ();
#endif
#ifdef DOC_WIN
	  else if (docwin && (data.Window == docwin))
	    showdocs (docline);
	  else if (xtrekrcwin && (data.Window == xtrekrcwin))
	    showxtrekrc (xtrekrcline);
#endif
	  break;
	default:
	  break;
	}
    }
}

#endif

keyaction (data)
     W_Event *data;
{
  char mbuf[80];
  char buf[80];
  char *t;
  int targettype;


#ifdef NBT
  int c;
  char who;
  int found;
#endif

  fastQuit = 0;			/* any event, cancel fastquit! */

  if (data->Window != mapw && data->Window != w && data->Window != infow
      && data->Window != scanw)
    return;

  key = data->key;

  if (data->Window == infow)
    {
      int x, y;
      if (findMouseInWin (&x, &y, w))
	{			/* local window */
	  data->Window = w;
	  data->x = x;
	  data->y = y;
	}
      else if (findMouseInWin (&x, &y, mapw))
	{			/* galactic window */
	  data->Window = mapw;
	  data->x = x;
	  data->y = y;
	}
    }


  /* this may represent a considerable efficiency improvement */
  /* removes the need for an INDEX and a couple tests */
  if (localflags & (PFREFIT))
    {
      switch (key)
	{
	case 'c':
	  sendRefitReq (CRUISER);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	case 'o':
	  sendRefitReq (STARBASE);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	case 'a':
	  sendRefitReq (ASSAULT);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	case 'd':
	  sendRefitReq (DESTROYER);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	case 'g':
	  sendRefitReq (SGALAXY);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	case 'b':
	  sendRefitReq (BATTLESHIP);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	case 's':
	  sendRefitReq (SCOUT);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	case '*':
	  sendRefitReq (ATT);
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	default:
	  localflags &= ~(PFREFIT);
	  return;
	  break;
	}
    }

  if (key >= 32 && key < MAXKEY)
    {
      key = mystats->st_keymap[key - 32];
    }
  else
    {
      W_Beep ();
      return;
    }


  /* suggestion:  later we can add an option removing this to
   ** the emptyKey() function.  This would improve input efficiency
   ** considerably when "singleMacro" is non-NULL. - jn
 */
  if (macroCheck (data))
    return;

  (*(key_handlers[key].handler)) (data);
}

#ifdef MOUSE_AS_SHIFT
mkeyaction (data)
     W_Event *data;
{
  unsigned char key = data->key;

  fastQuit = 0;			/* any event, cancel fastquit! */

  if (!INDEX ("sbogadc", key) || !(localflags & PFREFIT))
    {
      if (key >= 32 && key < 176)
	{
	  int offset;

	  switch (data->modifier)
	    {
	    case W_LBUTTON:
	      offset = 192;
	      break;

	    case W_MBUTTON:
	      offset = 288;
	      break;

	    case W_RBUTTON:
	      offset = 384;
	      break;
	    }

	  key = mystats->st_keymap[key - 32 + offset];
	}
    }

  data->key = key;
  keyaction (data);
}

#endif

buttonaction (data)
     W_Event *data;
{
  unsigned char course;
  struct obtype *gettarget ();

  if (messageon)
    message_off ();		/* ATM */

  fastQuit = 0;			/* any event, cancel fastquit! */

#ifdef SHORT_PACKETS
  if (data->Window == reviewWin)
    {
      if (recv_mesg)
	{
	  sendShortReq (SPK_MOFF);
	}
      else
	{
	  sendShortReq (SPK_MON);
	}
      return;
    }
#endif


  if (data->Window != w && data->Window != mapw
      && data->Window != infow
      && data->Window != scanwin)
    return;

#ifdef SHIFTED_MOUSE
  if (data->key >= W_LBUTTON && data->key <= W_RBUTTON4)
    {
      if (buttonmap[data->key] != '\0')
	{
	  data->key = buttonmap[data->key];
	  keyaction (data);
	  return;
	}
    }
#else
  if (data->key > 0 && data->key <= 3)
    {
      if (buttonmap[data->key] != '\0')
	{
	  data->key = buttonmap[data->key];
	  keyaction (data);
	  return;
	}
    }
#endif

  if (data->Window == infow)
    {
      int x, y;
      if (findMouseInWin (&x, &y, w))
	{			/* local window */
	  data->Window = w;
	  data->x = x;
	  data->y = y;
	}
      else if (findMouseInWin (&x, &y, mapw))
	{			/* galactic window */
	  data->Window = mapw;
	  data->x = x;
	  data->y = y;
	}
    }

  if (data->key == W_RBUTTON)
    {
      course = getcourse (data->Window, data->x, data->y);
      set_course (course);
    }
  else if (data->key == W_LBUTTON)
    {
      course = getcourse (data->Window, data->x, data->y);
      sendTorpReq (course);
    }
  else if (data->key == W_MBUTTON)
    {
      course = getcourse (data->Window, data->x, data->y);
      sendPhaserReq (course);
    }

#ifdef SHIFTED_MOUSE
  else if (data->key == W_RBUTTON2)
    {
      set_speed (me->p_ship.s_maxspeed / 2);
      localflags &= ~(PFREFIT);
    }
  else if (data->key == W_LBUTTON2)
    {
      set_speed (99);		/* Max speed... */
      localflags &= ~(PFREFIT);
    }
  else if (data->key == W_MBUTTON2)
    {
      detmine ();
    }
  else if (data->key == W_RBUTTON3)
    {
      if (!infomapped)
	{
	  inform (data->Window, data->x, data->y, 'i');
	  opened_info = keepInfo;	/* 5/31/93 LAB */
	}
      else
	{
	  destroyInfo ();
	  opened_info = -2;
	}
    }
  else if (data->key == W_LBUTTON3)
    {
      shield_tog ();
    }
  else if (data->key == W_MBUTTON3)
    {
      cloak ();
    }
  else if (data->key == W_RBUTTON4)
    {
      lockPlanetOrBase (data->Window, data->x, data->y);
    }
  else if (data->key == W_LBUTTON4)
    {
      struct obtype *gettarget (), *target;
      if (me->p_flags & (PFTRACT | PFPRESS))
	sendTractorReq (0, me->p_no);
      target = gettarget (data->Window, data->x, data->y, TARG_PLAYER);
      me->p_tractor = target->o_num;
      sendTractorReq (1, target->o_num);
    }
  else if (data->key == W_MBUTTON4)
    {
      struct obtype *gettarget (), *target;
      if (me->p_flags & (PFTRACT | PFPRESS))
	sendRepressReq (0, me->p_no);
      target = gettarget (data->Window, data->x, data->y, TARG_PLAYER);
      me->p_tractor = target->o_num;
      sendRepressReq (1, target->o_num);
    }
#endif
}

getcourse (ww, x, y)
     W_Window ww;
     int x, y;
{
  if (ww == mapw)
    {
      int me_x, me_y;

      me_x = me->p_x * WINSIDE / GWIDTH;
      me_y = me->p_y * WINSIDE / GWIDTH;
      return ((unsigned char) ((atan2 ((double) (x - me_x),
			     (double) (me_y - y)) / 3.14159 * 128.) + 0.5));
    }
  else
    return ((unsigned char) ((atan2 ((double) (x - WINSIDE / 2),
				     (double) (WINSIDE / 2 - y))
			      / 3.14159 * 128.) + 0.5));
}

scan (w, x, y)
{
}

detmine ()
{
  register int i;

  for (i = 0; i < MAXTORP; i++)
    {
      if (torps[i + (me->p_no * MAXTORP)].t_status == TMOVE ||
	  torps[i + (me->p_no * MAXTORP)].t_status == TSTRAIGHT)
	{
	  sendDetMineReq (i + (me->p_no * MAXTORP));

#ifdef SHORT_PACKETS
	  if (recv_short)
	    break;		/* Let the server det for me */
#endif
	}
    }
}

lockPlanetOrBase (ww, x, y)	/* special version of gettarget, 6/1/93 LAB */
     W_Window ww;
     int x, y;
{
  register int i;
  register struct player *j;
  register struct planet *k;
  int g_x, g_y;
  double dist, closedist;
  register int targtyp, targnum;

  if (ww == mapw)
    {
      g_x = x * GWIDTH / WINSIDE;
      g_y = y * GWIDTH / WINSIDE;
    }
  else
    {
      g_x = me->p_x + ((x - WINSIDE / 2) * SCALE);
      g_y = me->p_y + ((y - WINSIDE / 2) * SCALE);
    }
  closedist = GWIDTH;

  for (i = 0, k = &planets[i]; i < MAXPLANETS; i++, k++)
    {
      dist = hypot ((double) (g_x - k->pl_x), (double) (g_y - k->pl_y));
      if (dist < closedist)
	{
	  targtyp = PLANETTYPE;
	  targnum = i;
	  closedist = dist;
	}
    }

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (j->p_status != PALIVE)
	continue;
      if (j->p_flags & PFCLOAK)
	continue;
      if (j == me)
	continue;
      if ((j->p_ship.s_type == STARBASE) && (j->p_team == me->p_team))
	{
	  dist = hypot ((double) (g_x - j->p_x), (double) (g_y - j->p_y));
	  if (dist < closedist)
	    {
	      targtyp = PLAYERTYPE;
	      targnum = i;
	      closedist = dist;
	    }
	}
    }

  if (targtyp == PLAYERTYPE)
    {
      sendPlaylockReq (targnum);
      me->p_playerl = targnum;
    }
  else
    {
      sendPlanlockReq (targnum);
      me->p_planet = targnum;
    }

}


emptyKey ()
{
  W_Beep ();
}

macroCheck (data)
     W_Event *data;
{
  struct obtype *gettarget (), *target;
  int targettype;
  static struct itimerval udt;
  struct dmacro_list *dm;
  enum dist_type i;

#ifdef NBT
  int c;
  char who;
  int found;
#endif

#ifdef NBT
  if (!MacroMode && singleMacro[0] != '\0')
    {
      if (INDEX (singleMacro, data->key))
	macro_on ();
    }

  if (MacroMode)
    {
      found = 0;
      if (data->key == '?')
	{
	  showMacroWin ();
	  macro_off ();
	  return (1);
	}
      else
	{

	  /* user defined macros *OVERRIDE* receiver configurable distresses.  */

	  if (UseNewMacro)
	    {
	      /* sorry guys, I only program in kludge - jn 6/3/93 */
	      if (MacroNum > -1)
		{		/* macro identified, who to? */
		  if (MacroNum >= MAX_MACRO)
		    printf ("Unknown Macro Num!  Jeff's a twink!!\n");

		  if (!pmacro (MacroNum, data->key, data))
		    W_Beep ();

		  macro_off ();
		  return (1);
		}
	    }
	  for (c = 0; c < macrocnt && !found; c++)
	    {
	      if (macro[c].key == data->key)
		{
		  found = 1;
		  if (UseNewMacro)
		    {
		      switch (macro[c].type)
			{

			case NBTM:

			  pnbtmacro (c);
			  macro_off ();
			  return (1);
			  break;

			case NEWM:

			  MacroNum = c;
			  return (1);
			  break;

			case NEWMMOUSE:

			  /* first translate into who, then send */
			  switch (macro[c].who)
			    {

			      struct player *j;
			      struct planet *l;

			    case MACRO_FRIEND:
			    case MACRO_ENEMY:
			    case MACRO_PLAYER:

			      targettype = TARG_PLAYER;
			      if (macro[c].who == MACRO_ENEMY)
				targettype |= TARG_ENEMY;
			      else if (macro[c].who == MACRO_FRIEND)
				targettype |= TARG_FRIEND;

			      target = gettarget (data->Window, data->x, data->y,
						  TARG_PLAYER | TARG_CLOAK);
			      if (target->o_type == PLAYERTYPE)
				{
				  j = &players[target->o_num];
				  if (j->p_flags & PFCLOAK)
				    maskrecip = 1;
				  who = j->p_mapchars[1];
				}
			      else
				{
				  who = me->p_mapchars[1];
				  warning ("Can only send a message to a player");
				}
			      break;
			    case MACRO_TEAM:
			      target = gettarget (data->Window, data->x, data->y,
						  TARG_PLAYER | TARG_PLANET);
			      if (target->o_type == PLANETTYPE)
				{
				  l = &planets[target->o_num];
				  who = teamlet[l->pl_owner];
				}
			      else if (target->o_type == PLAYERTYPE)
				{
				  j = &players[target->o_num];
				  who = j->p_mapchars[0];
				}
			      else
				{
				  who = me->p_mapchars[1];
				  warning ("Player or planet only please");
				}
			      break;
			    default:
			      who = me->p_mapchars[1];
			      break;
			    }
			  if (!pmacro (c, who, data))
			    {
			      W_Beep ();
			    }
			  macro_off ();
			  return (1);
			  break;

			case NEWMSPEC:

			  if (!pmacro (c, macro[c].who, data))
			    {
			      W_Beep ();
			    }
			  macro_off ();
			  return (1);
			  break;

			default:

			  printf ("Unknown Macro Type!  Jeff's a twink!!\n");
			  break;

			}
		    }
		  else
		    {
		      if (rejectMacro && macro[c].type != NBTM)
			warning ("NEWMACROs not allowed at this server!!");
		      else
			pnbtmacro (c);
		      macro_off ();
		      return (1);
		    }
		}
	    }
	}

      /* scan for distress call here */

#ifdef DIST_KEY_NAME
      for (i = take; distmacro[i].name; i++)
	{
	  if (distmacro[i].c == data->key)
	    {
	      emergency (i, data);

	      macro_off ();
	      return (1);
	    }
	}
#endif

      macro_off ();
      return (0);

    }				/* macromode */
#endif

  return (0);
}

macro_off ()
{
  warning (" ");		/* clear warning message */
  MacroMode = 0;
  MacroNum = -1;
}

Key32 ()
{
  /* ' ' = clear special windows */
  W_UnmapWindow (planetw);
  W_UnmapWindow (rankw);
  if (infomapped)
    destroyInfo ();
  W_UnmapWindow (helpWin);

#ifdef NBT
  W_UnmapWindow (macroWin);
#endif

#ifdef XTREKRC_HELP
  if (defWin)
    W_UnmapWindow (defWin);
#endif

  W_UnmapWindow (war);
  if (optionWin)
    optiondone ();
  if (scanmapped)
    {
      W_UnmapWindow (scanwin);
      scanmapped = 0;
    }
  if (udpWin)
    udpdone ();

}

Key33 ()
{
  set_speed (11);
}

Key34 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key35 ()
{
  set_speed (me->p_ship.s_maxspeed / 2);
}

Key36 ()
{
  sendTractorReq (0, me->p_no);
}

Key37 ()
{
  set_speed (99);		/* Max speed... */
}

Key38 ()
{
  reread_defaults ();
}

Key39 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key40 ()
{
  set_speed (10);
}

Key41 (data)
     W_Event *data;
{
  set_speed (10);
}

Key42 ()
{
  sendPractrReq ();
}

Key43 ()
{
  /* UDP: pop up UDP control window */
  if (udpWin != NULL && W_IsMapped (udpWin))
    udpdone ();
  else
    {
      char buf[80];
      udpwindow ();
      sprintf (buf, "UDP client version %.1f",
	       (float) UDPVERSION / 10.0);
      warning (buf);
    }

}

Key44 ()
{
  if (W_IsMapped (pStats))
    {
      W_UnmapWindow (pStats);
    }
  else
    {
      W_MapWindow (pStats);
      redrawPStats ();
    }

}

Key45 ()
{

#ifdef SHORT_PACKETS
  sendShortReq (SPK_SALL);
#endif

}

Key46 ()
{
  if (netstatWin != NULL && W_IsMapped (netstatWin))
    nsdone ();
  else
    nswindow ();
}

Key47 ()
{
  sortPlayers = (!sortPlayers);
}

Key48 ()
{
  set_speed (0);
}

Key49 ()
{
  set_speed (1);
}

Key50 ()
{
  set_speed (2);
}

Key51 ()
{
  set_speed (3);
}

Key52 ()
{
  set_speed (4);
}

Key53 ()
{
  set_speed (5);
}

Key54 ()
{
  set_speed (6);
}

Key55 ()
{
  set_speed (7);
}

Key56 ()
{
  set_speed (8);
}

Key57 ()
{
  set_speed (9);
}

Key58 ()
{
  logmess = !logmess;
  if (logmess)
    warning ("Message logging is ON");
  else
    warning ("Message logging is OFF");

}

Key59 (data)
     W_Event *data;
{
  lockPlanetOrBase (data->Window, data->x, data->y);

}

/* < */
Key60 ()
{
  set_speed (me->p_speed - 1);
}

Key61 ()
{
  /* UDP: request for full update */
  sendUdpReq (COMM_UPDATE);
}

/* > */
Key62 ()
{
  set_speed (me->p_speed + 1);
}

Key63 ()
{
  if (W_IsMapped (phaserwin))
    phaserWindow = 1;
  if (!W_IsMapped (reviewWin))
    {
      if (W_IsMapped (messwa))
	{
	  W_UnmapWindow (messwa);
	  W_UnmapWindow (phaserwin);
	  W_UnmapWindow (messwt);
	  W_UnmapWindow (messwi);
	  W_UnmapWindow (messwk);
	}
      else
	{
	  W_MapWindow (reviewWin);
	}
    }
  else
    {
      W_UnmapWindow (reviewWin);
      W_MapWindow (messwa);
      W_MapWindow (messwt);
      W_MapWindow (messwi);
      W_MapWindow (messwk);
      if (phaserWindow)
	W_MapWindow (phaserwin);
      if (W_IsMapped (statwin))
	{
	  W_UnmapWindow (statwin);
	  W_MapWindow (statwin);
	}
    }
  if (optionWin)
    {
      optionredrawtarget (reviewWin);
      optionredrawtarget (messwa);
      optionredrawtarget (phaserwin);
      optionredrawtarget (messwt);
      optionredrawtarget (messwi);
      optionredrawtarget (messwk);
    }
}

Key64 ()
{
  set_speed (12);
}

Key65 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key66 ()
{
  showgalactic++;
  if (showgalactic == 3)
    showgalactic = 0;
#ifdef BRMH
  redrawall = 2;
#else
  redrawall = 1;
#endif
}

Key67 ()
{
  sendCoupReq ();
}

Key68 ()
{
  detmine ();

#ifdef AUTOKEY
  if (autoKey)
    autoKeyAllOff ();		/* xx */
#endif
}

/* E */
Key69 (data)
     W_Event *data;
{
  emergency (generic, data);
}

/* F */
Key70 (data)
     W_Event *data;
{
  emergency (carrying, data);
}

Key71 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key72 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key73 (data)
     W_Event *data;
{
  /* I = get extended information */
  if (!infomapped)
    {
      inform (data->Window, data->x, data->y, key);
      opened_info = keepInfo;	/* 5/31/93 LAB */
    }
  else
    {
      destroyInfo ();
      opened_info = -2;
    }

}

Key74 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key75 ()
{
  if (babes)
    hellokathy ();
}

Key76 ()
{
  if (W_IsMapped (playerw))
    {
      W_UnmapWindow (playerw);
    }
  else
    {
      W_MapWindow (playerw);
    }

}

Key77 (data)
     W_Event *data;
{
#ifdef TOOLS
  showToolsWin ();
#else
  emptyKey (data);
#endif
}

Key78 ()
{
  /* N = Toggle Name mode */
  namemode = !namemode;
  if (optionWin)
    optionredrawoption (&namemode);

}

Key79 ()
{
  if (optionWin != NULL && W_IsMapped (optionWin))
    optiondone ();
  else
    optionwindow ();
}

Key80 ()
{
  if (W_IsMapped (planetw))
    {
      W_UnmapWindow (planetw);
    }
  else
    {
      W_MapWindow (planetw);
    }

}

Key81 ()
{
#ifdef SOUND
  Play_Sound (SELF_DESTRUCT_SOUND);
#endif
  sendQuitReq ();

}

Key82 ()
{
  sendRepairReq (1);
}

Key83 ()
{
  if (W_IsMapped (statwin))
    {
      W_UnmapWindow (statwin);
    }
  else
    {
      W_MapWindow (statwin);
    }

}

Key84 (data)
     W_Event *data;
{
  if (me->p_flags & (PFTRACT | PFPRESS))
    {
      sendTractorReq (0, me->p_no);
      return;
    }
  target = gettarget (data->Window, data->x, data->y, TARG_PLAYER);
  me->p_tractor = target->o_num;
  if (key == 'T')
    {
      sendTractorReq (1, target->o_num);
    }
  else
    {
      sendRepressReq (1, target->o_num);
    }
}

Key85 ()
{
  if (W_IsMapped (rankw))
    {
      W_UnmapWindow (rankw);
    }
  else
    {
      W_MapWindow (rankw);
    }

}

/* I really should get paid for this... */
Key86 ()
{
  showlocal++;
  if (showlocal == 3)
    showlocal = 0;

}

Key87 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key88 ()
{
  macro_on ();
}

Key89 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key90 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key91 ()
{
  shield_down ();
}

Key92 ()
{
  if (netstat)
    {
      if (lMeter != NULL && W_IsMapped (lMeter))
	W_UnmapWindow (lMeter);
      else
	W_MapWindow (lMeter);
    }
  else
    {
      warning ("Network stats are not being collected!");
    }

}

Key93 ()
{
  shield_up ();
}

Key94 (data)
     W_Event *data;
{
  if (me->p_flags & (PFTRACT | PFPRESS))
    sendRepressReq (0, me->p_no);
  target = gettarget (data->Window, data->x, data->y, TARG_PLAYER);
  me->p_tractor = target->o_num;
  sendRepressReq (1, target->o_num);
}

Key95 (data)
     W_Event *data;
{
  if (me->p_flags & (PFTRACT | PFPRESS))
    sendTractorReq (0, me->p_no);
  target = gettarget (data->Window, data->x, data->y, TARG_PLAYER);
  me->p_tractor = target->o_num;
  sendTractorReq (1, target->o_num);
}

Key96 ()
{

#ifdef SHORT_PACKETS
  if (spWin != NULL && W_IsMapped (spWin))
    spdone ();
  else
    spwindow ();
#endif

}

Key97 (data)
     W_Event *data;
{
  if (!W_IsMapped (scanwin))
    {
      scan (data->Window, data->x, data->y);
    }
  else
    {
      if (scanmapped)
	W_UnmapWindow (scanwin);
      scanmapped = 0;
    }
}

Key98 ()
{

#ifdef AUTOKEY
  if (autoKey && !(localflags & PFREFIT))
    autoKeyBombReqOn ();
  else
    bomb_planet ();
#else
  bomb_planet ();
#endif /*AUTOKEY */

}

Key99 ()
{
  cloak ();

}

Key100 ()
{
  static struct itimerval udt;

#ifdef AUTOKEY
  if (autoKey)
    autoKeyDetReqOn ();
  else
    sendDetonateReq ();
#else
  /* want to limit these to one per update */
  if (detallow)
    {
      sendDetonateReq ();
      detallow = 0;
      (void) SIGNAL (SIGALRM, detsetallow);
      udt.it_interval.tv_sec = 0;
      udt.it_interval.tv_usec = 0;
      udt.it_value.tv_sec = 0;
      udt.it_value.tv_usec = UPDATE;
      (void) setitimer (ITIMER_REAL, &udt, (struct itimerval *) 0);
      /* hopefully this will reset detallow in 100msec */
    }
#endif /*AUTOKEY */

}

Key101 ()
{
  if (me->p_flags & PFDOCKOK)
    sendDockingReq (0);
  else
    sendDockingReq (1);
}

Key102 (data)
     W_Event *data;
{
  unsigned char course;
  /* f = launch plasma torpedos */

#ifdef AUTOKEY
  if (autoKey)
    autoKeyPlasmaReqOn ();
  else
    {
      course = getcourse (data->Window, data->x, data->y);
      sendPlasmaReq (course);
    }
#else
  course = getcourse (data->Window, data->x, data->y);
  sendPlasmaReq (course);
#endif /*AUTOKEY */

}

Key103 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key104 ()
{
  /* h = Map help window */
  if (W_IsMapped (helpWin))
    {
      W_UnmapWindow (helpWin);
    }
  else
    {
      fillhelp ();
      W_MapWindow (helpWin);
    }
  if (optionWin)
    optionredrawtarget (helpWin);

}

Key105 (data)
     W_Event *data;
{
  if (!infomapped)
    {
      inform (data->Window, data->x, data->y, key);
      opened_info = keepInfo;	/* 5/31/93 LAB */
    }
  else
    {
      destroyInfo ();
      opened_info = -2;
    }
}

Key106 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key107 (data)
     W_Event *data;
{
  unsigned char course;
  course = getcourse (data->Window, data->x, data->y);
  set_course (course);
  me->p_flags &= ~(PFPLOCK | PFPLLOCK);
}

Key108 (data)
     W_Event *data;
{
  target = gettarget (data->Window, data->x, data->y,
		      TARG_PLAYER | TARG_PLANET);
  if (target->o_type == PLAYERTYPE)
    {
      sendPlaylockReq (target->o_num);
      me->p_playerl = target->o_num;

    }
  else
    {				/* It's a planet */
      sendPlanlockReq (target->o_num);
      me->p_planet = target->o_num;
    }
}

Key109 ()
{
#ifdef SOUND
  Play_Sound (MESSAGE_SOUND);
#endif
  message_on ();
}

Key110 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key111 ()
{

#ifdef AUTOKEY
  if (autoKey)
    autoKeyOrbitReqOn ();
  else
    sendOrbitReq (1);
#else
  sendOrbitReq (1);
#endif /*AUTOKEY */

}

Key112 (data)
     W_Event *data;
{
  unsigned char course;

#ifdef AUTOKEY
  if (autoKey)
    autoKeyPhaserReqOn ();
  else
    {
      course = getcourse (data->Window, data->x, data->y);
      sendPhaserReq (course);
    }
#else
  course = getcourse (data->Window, data->x, data->y);
  sendPhaserReq (course);
#endif /*AUTOKEY */

}

Key113 ()
{
#ifdef SOUND
  Play_Sound (SELF_DESTRUCT_SOUND);
#endif
  fastQuit = 1;
  sendQuitReq ();
}

/* r */
Key114 ()
{
  localflags |= PFREFIT;
  warning ("s=scout, d=destroyer, c=cruiser, b=battleship, a=assault, g=galaxy, o=starbase/outpost");
}

Key115 ()
{
  shield_tog ();
}

Key116 (data)
     W_Event *data;
{
  unsigned char course;

#ifdef AUTOKEY
  if (autoKey)
    autoKeyTorpReqOn ();
  else
    {
      course = getcourse (data->Window, data->x, data->y);
      sendTorpReq (course);
    }
#else
  course = getcourse (data->Window, data->x, data->y);
  sendTorpReq (course);
#endif /*AUTOKEY */
}

Key117 ()
{
  shield_tog ();
}

Key118 (data)
     W_Event *data;
{
  emptyKey (data);
}

Key119 ()
{
  /* w = map war stuff */
  if (W_IsMapped (war))
    W_UnmapWindow (war);
  else
    warwindow ();

}

Key120 ()
{

#ifdef AUTOKEY
  if (autoKey)
    autoKeyBeamDownReqOn ();
  else
#endif

    beam_down ();

}

Key121 (data)
     W_Event *data;
{
  if (me->p_flags & (PFTRACT | PFPRESS))
    {
      sendTractorReq (0, me->p_no);
      return;
    }
  target = gettarget (data->Window, data->x, data->y, TARG_PLAYER);
  me->p_tractor = target->o_num;
  if (key == 'T')
    {
      sendTractorReq (1, target->o_num);
    }
  else
    {
      sendRepressReq (1, target->o_num);
    }

}

Key122 ()
{

#ifdef AUTOKEY
  if (autoKey)
    autoKeyBeamUpReqOn ();
  else
#endif

    beam_up ();

}

Key123 ()
{
  cloak_on ();
}

Key124 ()
{

#ifdef SHORT_PACKETS
  sendShortReq (SPK_ALL);
#endif

}

Key125 ()
{
  cloak_off ();
}

Key126 (data)
     W_Event *data;
{
#ifdef SOUND
  if ((soundWin != NULL) && W_IsMapped (soundWin))
    sounddone ();
  else
    soundwindow ();
#else
  emptyKey (data);
#endif
}

Key127 (data)
     W_Event *data;
{
  emptyKey (data);
}

macro_on ()
{
  warning ("In Macro Mode");
  MacroMode = 1;
  if (UseNewMacro)
    MacroNum = -1;
}

reread_defaults ()
{
  char mbuf[80];
  char buf[80];
  char *t;

  STRNCPY (buf, defaultsFile, sizeof (buf));
  if (buf)
    {
      sprintf (mbuf, "Re-reading  %s", buf);
      t = mbuf;
      warning (t);
      initDefaults (defaultsFile);
      initkeymap ();
      resetdefaults ();
    }
  else
    {
      warning ("no default file");
    }
}

/* ^T */
Key180 (data)
     W_Event *data;
{
  emergency (take, data);
}

/* ^t */
Key212 (data)
     W_Event *data;
{
  emergency (take, data);
}

/* ^o */
Key207 (data)
     W_Event *data;
{
  emergency (ogg, data);
}

/* ^b */
Key194 (data)
     W_Event *data;
{
  emergency (bomb, data);
}

/* ^c */
Key195 (data)
     W_Event *data;
{
  emergency (space_control, data);
}

/* ^1 */
Key145 (data)
     W_Event *data;
{
  emergency (save_planet, data);
}

/* ^2 */
Key146 (data)
     W_Event *data;
{
  emergency (base_ogg, data);
}

/* ^3 */
Key147 (data)
     W_Event *data;
{
  emergency (help3, data);
}

/* ^4 */
Key148 (data)
     W_Event *data;
{
  emergency (help4, data);
}

/* ^e */
Key197 (data)
     W_Event *data;
{
  emergency (escorting, data);
}

/* ^p */
Key208 (data)
     W_Event *data;
{
  emergency (ogging, data);
}

/* ^m */
Key205 (data)
     W_Event *data;
{
  emergency (bombing, data);
}

/* ^l */
Key204 (data)
     W_Event *data;
{
  emergency (controlling, data);
}


/* ^O */
Key175 (data)
     W_Event *data;
{
  emergency (ogging, data);
}

/* ^B */
Key162 (data)
     W_Event *data;
{
  emergency (bombing, data);
}

/* ^C */
Key163 (data)
     W_Event *data;
{
  emergency (controlling, data);
}

/* ^5 */
Key149 (data)
     W_Event *data;
{
  emergency (asw, data);
}

/* ^6 */
Key150 (data)
     W_Event *data;
{
  emergency (asbomb, data);
}

/* ^7 */
Key151 (data)
     W_Event *data;
{
  emergency (doing3, data);
}

/* ^8 */
Key152 (data)
     W_Event *data;
{
  emergency (doing4, data);
}

/* ^f */
Key198 (data)
     W_Event *data;
{
  emergency (free_beer, data);
}

/* ^n */
Key206 (data)
     W_Event *data;
{
  emergency (no_gas, data);
}

/* ^h */
Key200 (data)
     W_Event *data;
{
  emergency (crippled, data);
}

/* ^9 */
Key153 (data)
     W_Event *data;
{
  emergency (pickup, data);
}

/* ^0 */
Key144 (data)
     W_Event *data;
{
  emergency (pop, data);
}

/* ^@ */
Key160 (data)
     W_Event *data;
{
  emergency (other1, data);
}

/* ^# */
Key131 (data)
     W_Event *data;
{
  emergency (other2, data);
}
