
/* This file implements all SHORT_PACKETS functions */
/*  HW 19.07.93 */
#include "config.h"
#ifdef SHORT_PACKETS

#include INC_MACHINE_ENDIAN

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include INC_SYS_SELECT
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <math.h>
#include <errno.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

/* from here on all SHORT_PACKETS */
#include "wtext.h"		/* here are all warningdefines */

/*      Here are all warnings that are send with SP_S_WARNING */
/*              HW 93           */

/* DaemonMessages */
char *daemon_texts[] =
{
/* Game_Paused() */
  "Game is paused.  CONTINUE to continue.",	/* 0 */
  "Game is no-longer paused!",	/* 1 */
  "Game is paused. Captains CONTINUE to continue.",	/* 2 */
  "Game will continue in 10 seconds",	/* 3 */
/* send_about_to_start() */
  "Teams chosen.  Game will start in 1 minute.",	/* 4 */
  "----------- Game will start in 1 minute -------------",	/* 5 */
};

/* VARITEXTE = warnings with 1 or more arguments argument */
char *vari_texts[] =
{
/* redraw.c */
  "Engineering:  Energizing transporters in %d seconds",	/* 0 */
  "Stand By ... Self Destruct in %d seconds",	/* 1 */
  "Helmsman:  Docking manuever completed Captain.  All moorings secured at port %d.",	/* 2 */
/* interface.c from INL server */
  "Not constructed yet. %d minutes required for completion",	/* 3 */

};



char *w_texts[] =
{
/* socket.c             */
  "Tractor beams haven't been invented yet.",	/* 0 */
  "Weapons's Officer:  Cannot tractor while cloaked, sir!",	/* 1 */
  "Weapon's Officer:  Vessel is out of range of our tractor beam.",	/* 2 */

/* handleRepressReq */
/****************       coup.c  ***********************/
/*      coup()  */
  "You must have one kill to throw a coup",	/* 3 */
  "You must orbit your home planet to throw a coup",	/* 4 */
  "You already own a planet!!!",/* 5 */
  "You must orbit your home planet to throw a coup",	/* 6 */
  "Too many armies on planet to throw a coup",	/* 7 */
  "Planet not yet ready for a coup",	/* 8 */
/*      getentry.c              */
/*      getentry()              */
  "I cannot allow that.  Pick another team",	/* 9 */
  "Please confirm change of teams.  Select the new team again.",	/* 10 */
  "That is an illegal ship type.  Try again.",	/* 11 */
  "That ship hasn't beed designed yet.  Try again.",	/* 12 */
  "Your new starbase is still under construction",	/* 13 */
  "Your team is not capable of defending such an expensive ship!",	/* 14 */
  "Your team's stuggling economy cannot support such an expenditure!",	/* 15 */
  "Your side already has a starbase!",	/* 16 */
/*      plasma.c        */
/* nplasmatorp(course, type)    */
  "Plasmas haven't been invented yet.",	/* 17 */
"Weapon's Officer:  Captain, this ship is not armed with plasma torpedoes!",	/* 18 */
  "Plasma torpedo launch tube has exceeded the maximum safe temperature!",	/* 19 */
  "Our fire control system limits us to 1 live torpedo at a time captain!",	/* 20 */
  "Our fire control system limits us to 1 live torpedo at a time captain!",	/* 21 */
  "We don't have enough fuel to fire a plasma torpedo!",	/* 22 */
  "We cannot fire while our vessel is undergoing repairs.",	/* 23 */
  "We are unable to fire while in cloak, captain!",	/* 24 */
/********       torp.c  *********/
/*      ntorp(course, type)     */
  "Torpedo launch tubes have exceeded maximum safe temperature!",	/* 25 */
  "Our computers limit us to having 8 live torpedos at a time captain!",	/* 26 */
  "We don't have enough fuel to fire photon torpedos!",	/* 27 */
  "We cannot fire while our vessel is in repair mode.",	/* 28 */
  "We are unable to fire while in cloak, captain!",	/* 29 */
  "We only have forward mounted cannons.",	/* 30 */
/*      phasers.c       */
/*      phaser(course) */
  "Weapons Officer:  This ship is not armed with phasers, captain!",	/* 31 */
  "Phasers have not recharged",	/* 32 */
  "Not enough fuel for phaser",	/* 33 */
  "Can't fire while repairing",	/* 34 */
  "Weapons overheated",		/* 35 */
  "Cannot fire while cloaked",	/* 36 */
  "Phaser missed!!!",		/* 37 */
  "You destroyed the plasma torpedo!",	/* 38 */
/*      interface.c     */
/* bomb_planet()        */
  "Must be orbiting to bomb",	/* 39 */
  "Can't bomb your own armies.  Have you been reading Catch-22 again?",	/* 40 */
  "Must declare war first (no Pearl Harbor syndrome allowed here).",	/* 41 */
  "Bomb out of T-mode?  Please verify your order to bomb.",	/* 42 */
  "Hoser!",			/* 43 */
/*      beam_up()       */
  "Must be orbiting or docked to beam up.",	/* 44 */
  "Those aren't our men.",	/* 45 */
  "Comm Officer: We're not authorized to beam foriegn troops on board!",	/* 46 */
/* beam_down() */
  "Must be orbiting or docked to beam down.",	/* 47 */
  "Comm Officer: Starbase refuses permission to beam our troops over.",	/* 48 */
/*      declare_war(mask)       */
  "Pausing ten seconds to re-program battle computers.",	/* 49 */
/* do_refit(type) */
  "You must orbit your HOME planet to apply for command reassignment!",	/* 50 */
  "You must orbit your home planet to apply for command reassignment!",	/* 51 */
  "Can only refit to starbase on your home planet.",	/* 52 */
  "You must dock YOUR starbase to apply for command reassignment!",	/* 53 */
  "Must orbit home planet or dock your starbase to apply for command reassignment!",	/* 54 */
  "Central Command refuses to accept a ship in this condition!",	/*  55 */
  "You must beam your armies down before moving to your new ship",	/* 56 */
  "That ship hasn't been designed yet.",	/* 57 */
  "Your side already has a starbase!",	/* 58 */
  "Your team is not capable of defending such an expensive ship",	/* 59 */
  "Your new starbase is still under construction",	/* 60 */
  "Your team's stuggling economy cannot support such an expenditure!",	/* 61 */
  "You are being transported to your new vessel .... ",	/* 62 */
/* redraw.c */
/* auto_features()  */
  "Engineering:  Energize. [ SFX: chimes ]",	/* 63 */
  "Wait, you forgot your toothbrush!",	/* 64 */
  "Nothing like turning in a used ship for a new one.",	/* 65 */
  "First officer:  Oh no, not you again... we're doomed!",	/* 66 */
  "First officer:  Uh, I'd better run diagnostics on the escape pods.",	/* 67 */
  "Shipyard controller:  This time, *please* be more careful, okay?",	/* 68 */
  "Weapons officer:  Not again!  This is absurd...",	/* 69 */
  "Weapons officer:  ... the whole ship's computer is down?",	/* 70 */
  "Weapons officer:  Just to twiddle a few bits of the ship's memory?",	/* 71 */
  "Weapons officer:  Bah! [ bangs fist on inoperative console ]",	/* 72 */
  "First Officer:  Easy, big guy... it's just one of those mysterious",	/* 73 */
  "First Officer:  laws of the universe, like 'tires on the ether'.",	/* 74 */
  "First Officer:  laws of the universe, like 'Klingon bitmaps are ugly'.",	/* 75 */
  "First Officer:  laws of the universe, like 'all admirals have scummed'.",	/* 76 */
  "First Officer:  laws of the universe, like 'Mucus Pig exists'.",	/* 77 */
  "First Officer:  laws of the universe, like 'guests advance 5x faster'.",	/* 78 */
/* orbit.c */
/*orbit() */
  "Helmsman: Captain, the maximum safe speed for docking or orbiting is warp 2!",	/* 79 */
  "Central Command regulations prohibits you from orbiting foreign planets",	/* 80 */
  "Helmsman:  Sensors read no valid targets in range to dock or orbit sir!",	/* 81 */
/* redraw.c */
  "No more room on board for armies",	/* 82 */
  "You notice everyone on the bridge is staring at you.",	/* 83 */
/* startdaemon.c */
/* practice_robo() */
  "Can't send in practice robot with other players in the game.",	/* 84 */
/*      socket.c */
/*      doRead(asock) */
  "Self Destruct has been canceled",	/* 85 */
/* handleMessageReq(packet) */
  "Be quiet",			/* 86 */
  "You are censured.  Message was not sent.",	/* 87 */
  "You are ignoring that player.  Message was not sent.",	/* 88 */
  "That player is censured.  Message was not sent.",	/* 89 */
/* handleQuitReq(packet) */
  "Self destruct initiated",	/* 90 */
/* handleScan(packet) */
  "Scanners haven't been invented yet",	/* 91 */
/* handleUdpReq(packet) */
  "WARNING: BROKEN mode is enabled",	/* 92 */
  "Server can't do that UDP mode",	/* 93 */
  "Server will send with TCP only",	/* 94 */
  "Server will send with simple UDP",	/* 95 */
  "Request for fat UDP DENIED (set to simple)",	/* 96 */
  "Request for double UDP DENIED (set to simple)",	/* 97 */
/* forceUpdate() */
  "Update request DENIED (chill out!)",	/* 98 */
/* INL redraw.c */
  "Player lock lost while player dead.",	/* 99 */
  "Can only lock on own team.",	/* 100 */
  "You can only warp to your own team's planets!",	/* 101 */
  "Planet lock lost on change of ownership.",	/* 102 */
  " Weapons officer: Finally! systems are back online!",	/* 103 */

};

#define NUMWTEXTS (sizeof w_texts / sizeof w_texts[0])
#define NUMVARITEXTS ( sizeof vari_texts / sizeof   vari_texts[0])
#define NUMDAEMONTEXTS ( sizeof daemon_texts / sizeof daemon_texts[0])


extern char numofbits[];	/* How many 1 bits in a char */
extern int vtisize[];		/* 4 byte Header + torpdata */
int Plx[MAXPLAYER], Ply[MAXPLAYER], Pgx[MAXPLAYER], Pgy[MAXPLAYER];
unsigned char Pdir[MAXPLAYER];
/* SP_S_WARNING vari texte */
char *s_texte[256];		/* Better with a malloc scheme */
char no_memory[] =
{"Not enough memory for warning string!"};

/* For INL Server */
char *shiptype[NUM_TYPES] =
{"SC", "DD", "CA", "BB", "AS", "SB", "??"};
#define SPWINSIDE 500		/* To make it safe */

char *whydeadmess[] =
{"", "[quit]", "[photon]", "[phaser]", "[planet]", "[explosion]",
 "", "", "[ghostbust]", "[genocide]", "", "[plasma]", "[detted photon]", "[chain explosion]",
 "[TEAM]", "", "[team det]", "[team explosion]"};


handleSWarning (packet)
     struct warning_s_spacket *packet;
{
  char buf[80];
  register struct player *target;
  register int damage;
  static int arg3, arg4;	/* Here are the arguments for warnings with more than 2 arguments */
  static int karg3, karg4, karg5 = 0;
  char killmess[20];

  switch (packet->whichmessage)
    {
    case TEXTE:		/* damage used as tmp var */
      damage = (unsigned char) packet->argument;
      damage |= (unsigned char) packet->argument2 << 8;
      if (damage >= 0 && damage < NUMWTEXTS)
	warning (w_texts[damage]);
      break;
    case PHASER_HIT_TEXT:
      target = &players[(unsigned char) packet->argument & 0x3f];
      damage = (unsigned char) packet->argument2;
      if ((unsigned char) packet->argument & 64)
	damage |= 256;
      if ((unsigned char) packet->argument & 128)
	damage |= 512;
      (void) sprintf (buf, "Phaser burst hit %s for %d points", target->p_name, damage);
      warning (buf);
      break;
    case BOMB_INEFFECTIVE:
      sprintf (buf, "Weapons Officer: Bombing is ineffective.  Only %d armies are defending.",
	       (int) packet->argument);	/* nifty info feature 2/14/92 TMC */
      warning (buf);
      break;
    case BOMB_TEXT:
      sprintf (buf, "Weapons Officer: Bombarding %s...  Sensors read %d armies left.",
	       planets[(unsigned char) packet->argument].pl_name,
	       (unsigned char) packet->argument2);
      warning (buf);
      break;
    case BEAMUP_TEXT:
      sprintf (buf, "%s: Too few armies to beam up",
	       planets[(unsigned char) packet->argument].pl_name);
      warning (buf);
      break;
    case BEAMUP2_TEXT:
      sprintf (buf, "Beaming up. (%d/%d)", (unsigned char) packet->argument, (unsigned char) packet->argument2);
      warning (buf);
      break;
    case BEAMUPSTARBASE_TEXT:
      sprintf (buf, "Starbase %s: Too few armies to beam up",
	       players[packet->argument].p_name);
      warning (buf);
      break;
    case BEAMDOWNSTARBASE_TEXT:
      sprintf (buf, "No more armies to beam down to Starbase %s.",
	       players[packet->argument].p_name);
      warning (buf);

      break;
    case BEAMDOWNPLANET_TEXT:
      sprintf (buf, "No more armies to beam down to %s.",
	       planets[(unsigned char) packet->argument].pl_name);
      warning (buf);
      break;
    case SBREPORT:
      sprintf (buf, "Transporter Room:  Starbase %s reports all troop bunkers are full!",
	       players[packet->argument].p_name);
      warning (buf);
      break;
    case ONEARG_TEXT:
      if (packet->argument >= 0 && packet->argument < NUMVARITEXTS)
	{
	  sprintf (buf, vari_texts[packet->argument], (unsigned char) packet->argument2);
	  warning (buf);
	}
      break;
    case BEAM_D_PLANET_TEXT:
      sprintf (buf, "Beaming down.  (%d/%d) %s has %d armies left",
	       arg3,
	       arg4,
	       planets[(unsigned char) packet->argument].pl_name,
	       packet->argument2);
      warning (buf);
      break;
    case ARGUMENTS:
      arg3 = (unsigned char) packet->argument;
      arg4 = (unsigned char) packet->argument2;
      break;
    case BEAM_U_TEXT:
      sprintf (buf, "Transfering ground units.  (%d/%d) Starbase %s has %d armies left",
	       (unsigned char) arg3, (unsigned char) arg4, players[packet->argument].p_name, (unsigned char) packet->argument2);
      warning (buf);
      break;
    case LOCKPLANET_TEXT:
      sprintf (buf, "Locking onto %s", planets[(unsigned char) packet->argument].pl_name);
      warning (buf);
      break;
    case SBRANK_TEXT:
      sprintf (buf, "You need a rank of %s or higher to command a starbase!", ranks[packet->argument].name);
      warning (buf);
      break;
    case SBDOCKREFUSE_TEXT:
      sprintf (buf, "Starbase %s refusing us docking permission captain.",
	       players[packet->argument].p_name);
      warning (buf);
      break;
    case SBDOCKDENIED_TEXT:
      sprintf (buf, "Starbase %s: Permission to dock denied, all ports currently occupied.", players[packet->argument].p_name);
      warning (buf);
      break;
    case SBLOCKSTRANGER:
      sprintf (buf, "Locking onto %s (%c%c)",
	       players[packet->argument].p_name,
	       teamlet[players[packet->argument].p_team],
	       shipnos[players[packet->argument].p_no]);
      warning (buf);
      break;
    case SBLOCKMYTEAM:
      sprintf (buf, "Locking onto %s (%c%c) (docking is %s)",
	       players[packet->argument].p_name,
	       teamlet[players[packet->argument].p_team],
	       shipnos[players[packet->argument].p_no],
	       (players[packet->argument].p_flags & PFDOCKOK) ? "enabled" : "disabled");
      warning (buf);
      break;
    case DMKILL:
      {
	struct mesg_spacket msg;
	int killer, victim, armies;
	float kills;
	victim = (unsigned char) packet->argument & 0x3f;
	killer = (unsigned char) packet->argument2 & 0x3f;
	/* that's only a temp */
	damage = (unsigned char) karg3;
	damage |= (karg4 & 127) << 8;
	kills = damage / 100.0;
	if (kills == 0.0)
	  strcpy (killmess, "NO CREDIT");
	else
	  sprintf (killmess, "%0.2f", kills);
	armies = (((unsigned char) packet->argument >> 6) | ((unsigned char) packet->argument2 & 192) >> 4);
	if (karg4 & 128)
	  armies |= 16;
	if (armies == 0)
	  {
	    (void) sprintf (msg.mesg, "GOD->ALL %s (%c%c) was kill %s for %s (%c%c)",
			    players[victim].p_name,
			    teamlet[players[victim].p_team],
			    shipnos[victim],
			    killmess,
			    players[killer].p_name,
			    teamlet[players[killer].p_team],
			    shipnos[killer]);
	    msg.m_flags = MALL | MVALID | MKILL;
	  }
	else
	  {
	    (void) sprintf (msg.mesg, "GOD->ALL %s (%c%c+%d armies) was kill %s for %s (%c%c)",
			    players[victim].p_name,
			    teamlet[players[victim].p_team],
			    shipnos[victim],
			    armies,
			    killmess,
			    players[killer].p_name,
			    teamlet[players[killer].p_team],
			    shipnos[killer]);
	    msg.m_flags = MALL | MVALID | MKILLA;
	  }
	if (why_dead)
	  {
	    add_whydead (msg.mesg, karg5);
	    karg5 = 0;
	  }
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_recpt = 0;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case KILLARGS:
      karg3 = (unsigned char) packet->argument;
      karg4 = (unsigned char) packet->argument2;
      break;
    case KILLARGS2:
      karg5 = (unsigned char) packet->argument;
      break;
    case DMKILLP:
      {
	struct mesg_spacket msg;
	(void) sprintf (msg.mesg, "GOD->ALL %s (%c%c) killed by %s (%c)",
			players[packet->argument].p_name,
			teamlet[players[packet->argument].p_team],
			shipnos[packet->argument],
			planets[(unsigned char) packet->argument2].pl_name,
	      teamlet[planets[(unsigned char) packet->argument2].pl_owner]);
	if (why_dead)
	  {
	    add_whydead (msg.mesg, karg5);
	    karg5 = 0;
	  }
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_flags = MALL | MVALID | MKILLP;
	msg.m_recpt = 0;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case DMBOMB:
      {
	struct mesg_spacket msg;
	char buf1[80];
	(void) sprintf (buf, "%-3s->%-3s", planets[(unsigned char) packet->argument2].pl_name, teamshort[planets[(unsigned char) packet->argument2].pl_owner]);
	(void) sprintf (buf1, "We are being attacked by %s %c%c who is %d%% damaged.",
			players[packet->argument].p_name,
			teamlet[players[packet->argument].p_team],
			shipnos[packet->argument],
			arg3);
	(void) sprintf (msg.mesg, "%s %s", buf, buf1);
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_flags = MTEAM | MBOMB | MVALID;
	msg.m_recpt = planets[(unsigned char) packet->argument2].pl_owner;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case DMDEST:
      {
	struct mesg_spacket msg;
	char buf1[80];
	(void) sprintf (buf, "%s destroyed by %s (%c%c)",
			planets[(unsigned char) packet->argument].pl_name,
			players[packet->argument2].p_name,
			teamlet[players[packet->argument2].p_team],
			shipnos[(unsigned char) packet->argument2]);
	(void) sprintf (buf1, "%-3s->%-3s",
			planets[(unsigned char) packet->argument].pl_name, teamshort[planets[(unsigned char) packet->argument].pl_owner]);
	(void) sprintf (msg.mesg, "%s %s", buf1, buf);
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_flags = MTEAM | MDEST | MVALID;
	msg.m_recpt = planets[(unsigned char) packet->argument].pl_owner;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case DMTAKE:
      {
	struct mesg_spacket msg;
	char buf1[80];
	(void) sprintf (buf, "%s taken over by %s (%c%c)",
			planets[(unsigned char) packet->argument].pl_name,
			players[packet->argument2].p_name,
			teamlet[players[packet->argument2].p_team],
			shipnos[packet->argument2]);
	(void) sprintf (buf1, "%-3s->%-3s",
			planets[(unsigned char) packet->argument].pl_name, teamshort[players[packet->argument2].p_team]);
	(void) sprintf (msg.mesg, "%s %s", buf1, buf);
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_flags = MTEAM | MTAKE | MVALID;
	msg.m_recpt = players[packet->argument2].p_team;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case DGHOSTKILL:
      {
	struct mesg_spacket msg;
	ushort damage;
	damage = (unsigned char) karg3;
	damage |= (unsigned char) (karg4 & 0xff) << 8;
	(void) sprintf (msg.mesg, "GOD->ALL %s (%c%c) was kill %0.2f for the GhostBusters",
			players[(unsigned char) packet->argument].p_name, teamlet[players[(unsigned char) packet->argument].p_team],
			shipnos[(unsigned char) packet->argument],
			(float) damage / 100.0);
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_flags = MALL | MVALID;
	msg.m_recpt = 0;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
      /* INL Daemon Mesages */
    case INLDMKILLP:
      {
	struct mesg_spacket msg;
	sprintf (buf, "");
	if (arg3)
	  {			/* Armies */
	    sprintf (buf, "+%d", arg3);
	  }
	(void) sprintf (msg.mesg, "GOD->ALL %s(%s) (%c%c%s) killed by %s (%c)",
			players[(unsigned char) packet->argument].p_name,
	  shiptype[players[(unsigned char) packet->argument].p_ship.s_type],
		  teamlet[players[(unsigned char) packet->argument].p_team],
			shipnos[(unsigned char) packet->argument],
			buf,
			planets[(unsigned char) packet->argument2].pl_name,
	      teamlet[planets[(unsigned char) packet->argument2].pl_owner]);
	if (why_dead)
	  {
	    add_whydead (msg.mesg, karg5);
	    karg5 = 0;
	  }
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_flags = MALL | MVALID | MKILLP;
	msg.m_recpt = 0;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case INLDMKILL:
      {
	struct mesg_spacket msg;
	int killer, victim, armies;
	float kills;
	victim = (unsigned char) packet->argument & 0x3f;
	killer = (unsigned char) packet->argument2 & 0x3f;
	/* that's only a temp */
	damage = (unsigned char) karg3;
	damage |= (karg4 & 127) << 8;
	kills = damage / 100.0;
	armies = (((unsigned char) packet->argument >> 6) | ((unsigned char) packet->argument2 & 192) >> 4);
	if (karg4 & 128)
	  armies |= 16;
	if (armies == 0)
	  {
	    (void) sprintf (msg.mesg, "GOD->ALL %s(%s) (%c%c) was kill %0.2f for %s(%s) (%c%c)",
			    players[victim].p_name,
			    shiptype[players[victim].p_ship.s_type],
			    teamlet[players[victim].p_team],
			    shipnos[victim],
			    kills,
			    players[killer].p_name,
			    shiptype[players[killer].p_ship.s_type],
			    teamlet[players[killer].p_team],
			    shipnos[killer]);
	    msg.m_flags = MALL | MVALID | MKILL;
	  }
	else
	  {
	    (void) sprintf (msg.mesg, "GOD->ALL %s(%s) (%c%c+%d armies) was kill %0.2f for %s(%s) (%c%c)",
			    players[victim].p_name,
			    shiptype[players[victim].p_ship.s_type],
			    teamlet[players[victim].p_team],
			    shipnos[victim],
			    armies,
			    kills,
			    players[killer].p_name,
			    shiptype[players[killer].p_ship.s_type],
			    teamlet[players[killer].p_team],
			    shipnos[killer]);
	    msg.m_flags = MALL | MVALID | MKILLA;
	  }
	if (why_dead)
	  {
	    add_whydead (msg.mesg, karg5);
	    karg5 = 0;
	  }
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_recpt = 0;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case INLDRESUME:
      {
	struct mesg_spacket msg;
	sprintf (msg.mesg, " Game will resume in %d seconds", (unsigned char) packet->argument);
	msg.m_flags = MALL | MVALID;
	msg.type = SP_MESSAGE;
	msg.mesg[79] = '\0';
	msg.m_recpt = 0;
	msg.m_from = 255;
	handleMessage (&msg);
      }
      break;
    case INLDTEXTE:
      if (packet->argument >= 0 && (unsigned char) packet->argument < NUMDAEMONTEXTS)
	{
	  struct mesg_spacket msg;
	  strcpy (msg.mesg, daemon_texts[(unsigned char) packet->argument]);
	  msg.m_flags = MALL | MVALID;
	  msg.type = SP_MESSAGE;
	  msg.mesg[79] = '\0';
	  msg.m_recpt = 0;
	  msg.m_from = 255;
	  handleMessage (&msg);
	}
      break;
    case STEXTE:
      warning (s_texte[(unsigned char) packet->argument]);
      break;
    case SHORT_WARNING:
      {
	struct warning_spacket *warn = (struct warning_spacket *) packet;
	warning (warn->mesg);
      }
      break;
    case STEXTE_STRING:
      {
	struct warning_spacket *warn = (struct warning_spacket *) packet;
	warning (warn->mesg);
	s_texte[(unsigned char) warn->pad2] = (char *) malloc (warn->pad3 - 4);
	if (s_texte[(unsigned char) warn->pad2] == NULL)
	  {
	    s_texte[(unsigned char) warn->pad2] = no_memory;
	    warning ("Could not add warning! (No memory!)");
	  }
	else
	  strcpy (s_texte[(unsigned char) warn->pad2], warn->mesg);
      }
      break;
    default:
      warning ("Unknown Short Warning!");
      break;
    }
}

#define MY_SIZEOF(a) (sizeof(a) / sizeof(*(a)))

add_whydead (s, m)		/* 7/22/93 LAB */
     char *s;
     int m;
{
  char b[256];

  if (m < MY_SIZEOF (whydeadmess))
    {
      sprintf (b, "%-50s %s", s, whydeadmess[m]);
      b[79] = '\0';
      strcpy (s, b);
    }
}

#endif

/* END SHORT_PACKETS */
