/*
 * AutoSpam
 *
 * $Author: flan $
 * $Date: 1994/03/01 06:54:53 $
 *
 * $Log: strat_spam.c,v $
 * Revision 2.0  1994/03/01  06:54:53  flan
 * Autospam First Release
 *
 * Revision 1.4  1993/12/04  23:04:23  flan
 * -First Stupid Release
 *
 * Revision 1.4  1993/12/04  23:04:23  flan
 * Made strat-local things static, changed team test to work.
 *
 * Revision 1.3  1993/11/24  10:40:15  flan
 * Split things up a bit more intelligently.  Also, I changed things so
 * that various constants are only checked when entering SpamMode.  Oh,
 * yeah, I also made StartSpam and ExitSpam functions.  (They're in
 * there.)  Most importantly, it now shoots.  It's not the best, but hey.
 * Also, there's a bit of change to the way it chases the puck.  Should
 * prevent racing by the puck at max warp.
 *
 * Revision 1.2  1993/11/23  10:44:46  flan
 * Changed the shielding code to only shield when enough fuel and we
 * weren't damaged enough to want to die.  This seems like a good deal.
 * Next it should det correctly.  Also changed the message code so that
 * it couldn't be easily fooled by players.
 *
 */

/* 	$Id: strat_spam.c,v 2.0 1994/03/01 06:54:53 flan Rel $	 */

#ifndef lint
static char vcid[] = "$Id: strat_spam.c,v 2.0 1994/03/01 06:54:53 flan Rel $";
#endif /* lint */

#include <stdio.h>
#include <math.h>
#include "config.h"
#include "copyright.h"

#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#include "bot.h"

typedef enum 
{
  Wait,
  LockOntoPuck,
  ChasePuck,
  TurnTowardGoal,
  ShootAtGoal,
  Grunk,
  Faceoff,
  Blast
} MajorPlanType;

typedef enum
{
  Start,
  TurnToHomePlanet,
  GoToHomePlanet,
  OrbitHomePlanet,
  WaitABit,
  RaceTowardLine
} GrunkPlanType;

static MajorPlanType Plan = LockOntoPuck;
static GrunkPlanType GrunkPlan = Start;

static struct planet *RightGoalPost = 0;
static struct planet *LeftGoalPost = 0;

static struct planet *Home = 0;
static short old_team = 0;

static int PUCK;
static struct player *Puck = 0;
static unsigned char CourseToPuck;
static int DistToPuck;
static int PlayerNearestPuck;



void
StartSpamStrategy( void )
{
  PUCK = GetPlayerByName("Puck");
  Puck = &(players[PUCK]);

  old_team = me->p_team;
  if (me->p_team & KLI) 
    {
	  printf("KLINGON\n");
      LeftGoalPost  = &(planets[GetPlanetByName("Spica")]);
      RightGoalPost = &(planets[GetPlanetByName("Cassiopia")]);
      Home = &(planets[GetPlanetByName("Klingus")]);
    }
  else if (me->p_team & ORI)
    {
	  printf("ORION\n");
      LeftGoalPost  = &(planets[GetPlanetByName("Scorpii")]);
      RightGoalPost = &(planets[GetPlanetByName("Lyrae")]);
      Home = &(planets[GetPlanetByName("Orion")]);
    }
  else
	old_team = 0;

  Plan = LockOntoPuck;
}

void
StopSpamStrategy( void )
{
}

  

void
DoGrunkPlan( void )
{
  unsigned char the_course;
      
  the_course = getglobalcourse( Home->pl_x, Home->pl_y );

  if (GrunkPlan == Start)
    {
      pmessage("Grunking on 10", me->p_team, MTEAM);
      GrunkPlan = TurnToHomePlanet;
    }
  
  if (GrunkPlan == TurnToHomePlanet)
    {
      set_course( the_course );
      
      if (angdist(the_course, me->p_dir) < 5)
	{
	  GrunkPlan = GoToHomePlanet;
	}
    }
  
  if (GrunkPlan == GoToHomePlanet)
    {
      double dx, dy;
      
      dx = me->p_x - Home->pl_x;
      dy = me->p_y - Home->pl_y;
      
      set_speed(3);
      
      if (hypot( dx, dy ) < ENTORBDIST)
	{
	  GrunkPlan = OrbitHomePlanet;
	}
    }
  
  if (GrunkPlan == OrbitHomePlanet)
    {
      if (me->p_flags & PFORBIT)
	{
	  GrunkPlan = WaitABit;
	}
      else
	{
	  set_speed(1);
	  sendOrbitReq(1);
	}
    }
  
  if (GrunkPlan == WaitABit)
    {
    }
  
  if (GrunkPlan == RaceTowardLine)
    {
      if (me->p_team == KLI)
	{
	  set_course(128);
	}
      else
	{
	  set_course(0);
	}
      set_speed(me->p_ship.s_maxspeed);
    }
}
      

void
DoSpamStrategy( void )
{
  if (me->p_team != old_team)
	StartSpamStrategy();
  CourseToPuck = getglobalcourse(Puck->p_x, Puck->p_y);
  DistToPuck = (int) hypot((double) Puck->p_x - me->p_x,
			   (double) Puck->p_y - me->p_y);
  PlayerNearestPuck = PlayerNearestPlayer(PUCK);

  if ((me->p_shield < (me->p_ship.s_maxshield / 8))
      || (me->p_damage > (me->p_ship.s_maxdamage / 4))
      || (me->p_fuel < (me->p_ship.s_maxfuel / 2)))
    {
      shield_down();
    }
  else
    AutoShield();

  if ((me->p_fuel > (me->p_ship.s_maxfuel / 2))
      && (PlayerNearestPuck != me->p_no))
    {
      AutoTorp();
      /* AutoTorpPlayer(PlayerNearestPuck); */
      /* AutoPhaser(); */
    }

  if (Plan == Grunk)
    {
     warning("Plan: Grunk");
     DoGrunkPlan();
    }

  if (Plan == Wait)
    {
      warning("Plan: Wait");
      if (me->p_speed > 0)
	{
	  set_speed(0);
	}
    }

  if (Plan == LockOntoPuck)
    {
      warning("Plan: LockOntoPuck");
      
      set_speed(3);
      set_course(CourseToPuck);
      
      if (ABS(angdist(me->p_dir, CourseToPuck)) < 10)
	{
	  Plan = ChasePuck;
	}
    }
  if (Plan == ChasePuck)
    {
      warning("Plan: ChasePuck");
      set_speed(me->p_ship.s_maxspeed);
      set_course(CourseToPuck);
      
      /* printf("Player Nearest Puck = %i\n", PlayerNearestPlayer(PUCK));
      printf("Puck: Shields %s\n",
	     (players[PUCK].p_flags & PFSHIELD) ? "UP" : "DOWN"); */
      
      if ((PlayerNearestPuck == me->p_no)
	  && (Puck->p_flags & PFSHIELD))
	{
	  Plan = TurnTowardGoal;
	} 
      else
	{
	  if (!(me->p_flags & PFTRACT)
	      && (DistToPuck < 3 * TRACTDIST / 2))
	    {
	      sendTractorReq(1, PUCK);
	      me->p_tractor = PUCK;
	    }
	  else
	    {
	      if (me->p_tractor != PUCK)
		{
		  sendTractorReq(0, me->p_no);
		}
	    }
	  
	  if (((angdist(me->p_dir, CourseToPuck) >= 10)
	       && !(me->p_flags & (PFTRACT)))
	      || ((angdist(me->p_dir, CourseToPuck) >= 10)
		  && (PlayerNearestPuck != me->p_no)
		  && (DistToPuck > TRACTDIST)))
/*	      || (DistToPuck > DistBetweenPlayers(me->p_no, PUCK) */
	    {
	      Plan = LockOntoPuck;
	    }
	}
    }
  if (Plan == TurnTowardGoal)
    {
      warning("Plan: TurnTowardGoal");
      
      if (PlayerNearestPuck != me->p_no)
	{
	  Plan = LockOntoPuck;
	}
      else
	{
	  int goalCenterX;
	  int goalCenterY;
	  unsigned char the_course;

	  goalCenterX = (LeftGoalPost->pl_x + RightGoalPost->pl_x) / 2;
	  goalCenterY = (LeftGoalPost->pl_y + RightGoalPost->pl_y) / 2;

	  /* printf("left, right = %i, %i \n", left, right);
	  
	  printf("planets[left].pl_x == %i\n", planets[left].pl_x);
	  printf("planets[right].pl_x == %i\n", planets[right].pl_x); */
	  
	  if (ABS(angdist(me->p_dir, the_course) > 10))
	    {
	      set_speed(0);
	    }
	     
	  the_course = getglobalcourse(goalCenterX, goalCenterY);
	  set_course(the_course);
	  
	  if (ABS(angdist(me->p_dir, the_course)) < 5)
	    {
	      Plan = ShootAtGoal;
	    }
	}
    }
  if (Plan == ShootAtGoal)
    {
      warning("Plan: ShootAtGoal");
      
      if (me->p_flags & (PFTRACT | PFPRESS))
	{
	  sendTractorReq (0, me->p_no);
	}
      sendRepressReq(1, Puck->p_no);
      Plan = ChasePuck;
    }
  if (Plan == Blast)
    {
      if ((me->p_ntorp < 4) || (PlayerNearestPuck == me->p_no))
	{
	  Plan = LockOntoPuck;
	}
      else
	{
	  struct Enemy *mine;
	  
	  mine = (struct Enemy *) get_nearest(1);
	  if ((mine != 0) && (mine != NOENEMY))
	    {
	      set_course(mine->e_course);
	    }
	  else
	    {
	      Plan = LockOntoPuck;
	    }
	}
    }
}


void
DoSpamMessage( char *message, int len )
{
  char scratch[80];
  char t = message[0], p = message[1];
  int from, to;
  
  from = GetPlayerFromMessage(&(message[1]));
  to = GetPlayerFromMessage(&(message[5]));
  
  if ((from >= 0) && strstr(message, "mode"))
    {
      pmessage("AutoSpam Mode", from, MINDIV);
    }

  if ((strncmp(message, "Puck", 4) == 0)
      && strstr(message, "Faceoff in 30 seconds"))
    {
      switch (1 /*RANDOM() % 3*/)
	{
	case 0:
	  Plan = Wait;
	  break;
	case 1:
	  Plan = Grunk;
	  GrunkPlan = Start;
	  break;
	case 2:
	  Plan = Wait; /* Faceoff; */
	  break;
	default:
	  fprintf(stderr,"Error!!!\n");
	  abort(1);
	}
    }

  if ((strncmp(message, "Puck", 4) == 0)
      && strstr(message, "Faceoff in 10 seconds") && (Plan == Grunk))
    {
      GrunkPlan = RaceTowardLine;
    }

  if ((strncmp(message, "Puck", 4) == 0) && strstr(message, "<thunk!>"))
    {
      Plan = ShootAtGoal;
    }
  
  if ((strncmp(message, "Puck", 4) == 0) && strstr(message, "scores for the"))
    {
      Plan = Wait;
    }

  if ((strncmp(message, "Puck", 4) == 0) && strstr(message, "END OF"))
    {
      Plan = Wait;
    }
  
  DoGeneralMessage( message, len );
}
